incorrectClause(Obs, RealElem, Clause) :-
    userdefined(Obs, Atom),
    observableClause(Obs, Atom, ClauseE, Body, Clause),
    meetTheAnswers(Obs, Body, ClauseE, RealBodyEs),
    domainProject(Obs, Atom, RealBodyEs, RealEs),
    domainSingleton(Obs, RealE, RealEs),
    not(  (observableAnswers(Obs, Atom, IntendedEs),
          domainSingleton(Obs, RealE, IntendedEs))    ),
    showAelement(Obs, Atom, RealE, RealElem).
    
uncoveredE(Obs, IntendedElem) :-
    userdefined(Obs, Atom),
    observableAnswers(Obs, Atom, IntendedEs),
    domainSingleton(Obs, IntendedE, IntendedEs),
    not( (  findall(  (R, ClauseE, Body),
        (observableClause(Obs, Atom, ClauseE, Body, _),R=Atom), Bodies),
      joinTheAnswers(Obs,  Atom, Bodies, RealEs),
      domainSingleton(Obs, IntendedE, RealEs)   ) ),
    showAelement(Obs, Atom, IntendedE, IntendedElem).

meetTheAnswers(_Obs, true, E, E) :- !.
meetTheAnswers(Obs, (Atom,Atoms), E, E2) :- !,
    observableAnswers(Obs, Atom, AtomEs),
    domainMeet(Obs, E, AtomEs, E1),
    meetTheAnswers(Obs, Atoms, E1, E2).
meetTheAnswers(Obs, Atom, E, E1) :-
    observableAnswers(Obs, Atom, AtomEs),
    domainMeet(Obs, E, AtomEs, E1).
    
joinTheAnswers(Obs, _, [], Bottom) :- domainBottom(Obs, Bottom).
joinTheAnswers(Obs, Atom, [(Atom, ClauseE, Body)|Bodies], Es):-
    meetTheAnswers(Obs, Body, ClauseE, RealBodyEs),
    domainProject(Obs, Atom, RealBodyEs, SingleEs),
    joinTheAnswers(Obs, Atom, Bodies, PartialEs),
    domainJoin(Obs,SingleEs,PartialEs,Es).

oracle(Obs, A, E) :- oracleMemory(Obs, A, E), E \== no_more_ans.
oracle(Obs, A, E) :- not( oracleMemory(Obs, A, no_more_ans) ),
    oracleAsk(Obs, A, E).
oracleAsk(Obs, A, E) :- nl,write('Any (other) answer for goal '),
    write(A),write(' wrt obs. '),write(Obs),write(' ?'),nl,write('>'),
    readObs(Obs,A,E), (E \== no -> asserta( (oracleMemory(Obs, A, E)) );
        assert( (oracleMemory(Obs, A, no_more_ans)) ), fail).
oracleAsk(Obs, A, E) :- not( oracleMemory(Obs, A, no_more_ans) ),
    oracleAsk(Obs, A, E).
