member(X,[X|_Xs]).
member(X,[Y|Xs]):- X \== Y, member(X,Xs).

append([],Xs,Xs).
append([X|Xs],Ys,[X|Zs]) :- append(Xs,Ys,Zs).

diagnose(Obs, Atoms, Prog) :- assertSig(Obs, Atoms),assertProg(Prog).
assertSig(Obs, []).
assertSig(Obs, [Atom|Atoms]) :-
    assert( (userdefined(Obs, Atom)) ), assertSig(Obs, Atoms).
assertProg([]).
assertProg([Clause|Prog]) :- assert(Clause), assertProg(Prog).

incorrectClause(Obs, missing, spec) :- not(userdefined(Obs, _Atom)).
incorrectClause(partial(Obs), missing, spec) :- not(userdefined(partial(Obs), _Atom)).
incorrectClause(Obs, Mod, missing, spec(Mod)) :- not(userdefined(Obs, Mod, _Atom)).
uncoveredE(Obs, missingspec) :- not(userdefined(Obs, _Atom)).
uncoveredE(partial(Obs), missingspec) :- not(userdefined(partial(Obs), _Atom)).
uncoveredE(Obs, Mod, missingspec(Mod)) :- not(userdefined(Obs, Mod, _Atom)).

forget :- retract(oracleMemory(X, Y, Z)),!,forget.
forget.